/***************************************************
//Web: http://www.buydisplay.com
EastRising Technology Co.,LTD
****************************************************/

#include <bcm2835.h>
#include <stdio.h>
#include "nv3007.h"

char buffer[TFT_WIDTH * TFT_HEIGHT * 2];

void command(char cmd) {
    bcm2835_gpio_write(DC, LOW);
    bcm2835_spi_transfer(cmd);
}

void data(char cmd) {
    bcm2835_gpio_write(DC, HIGH);
    bcm2835_spi_transfer(cmd);
}

void nv3007_begin()
{
    bcm2835_gpio_fsel(RST, BCM2835_GPIO_FSEL_OUTP);
    bcm2835_gpio_fsel(DC, BCM2835_GPIO_FSEL_OUTP);

    bcm2835_spi_begin();
    bcm2835_spi_setBitOrder(BCM2835_SPI_BIT_ORDER_MSBFIRST);     //The default
    bcm2835_spi_setDataMode(BCM2835_SPI_MODE0);                  //The default
    bcm2835_spi_setClockDivider(BCM2835_SPI_CLOCK_DIVIDER_64);  //The default
    bcm2835_spi_chipSelect(BCM2835_SPI_CS0);                     //The default
    bcm2835_spi_setChipSelectPolarity(BCM2835_SPI_CS0, LOW);     //the default

    bcm2835_gpio_write(RST, HIGH);
    bcm2835_delay(10);
    bcm2835_gpio_write(RST, LOW);
    bcm2835_delay(20);
    bcm2835_gpio_write(RST, HIGH);
    bcm2835_delay(50);

	command(0xff);
	data(0xa5);
	command(0x9a);
	data(0x08);
	command(0x9b);
	data(0x08);
	command(0x9c);
	data(0xb0);
	command(0x9d);
	data(0x17);
	command(0x9e);
	data(0xc2);
	command(0x8f);
	data(0x22);
	data(0x04);
	command(0x84);
	data(0x90);
	command(0x83);
	data(0x7B);
	command(0x85);
	data(0x4F);
    ////GAMMA---------------------------------/////////////
    //V0[3:0]
	command(0x6e);
	data(0x0f);
	command(0x7e);
	data(0x0f);

    //V63[3:0]
	command(0x60);
	data(0x00);
	command(0x70);
	data(0x00);
    //V1[5:0] 
	command(0x6d);
	data(0x39);
	command(0x7d);
	data(0x31);
    //V62[5:0]
	command(0x61);
	data(0x0A);
	command(0x71);
	data(0x0A);
    //V2[5:0]
	command(0x6c);
	data(0x35);
	command(0x7c);
	data(0x29);
    //V61[5:0]
	command(0x62);
	data(0x0F);
	command(0x72);
	data(0x0F);
    //V20[6:0]
	command(0x68);
	data(0x4f);
	command(0x78);
	data(0x45);
    //V43[6:0]
	command(0x66);
	data(0x33);
	command(0x76);
	data(0x33);
    //V4[4:0]
	command(0x6b);
	data(0x14);
	command(0x7b);
	data(0x14);
    //V59[4:0]
	command(0x63);
	data(0x09);
	command(0x73);
	data(0x09);
    //V6[4:0]
	command(0x6a);
	data(0x13);
	command(0x7a);
	data(0x16);
    //V57[4:0]
	command(0x64);
	data(0x08);
	command(0x74);
	data(0x08);
	command(0x69);
	data(0x07);
	command(0x79);
	data(0x0d);
	command(0x65);
	data(0x05);
	command(0x75);
	data(0x05);
	command(0x67);
	data(0x33);
	command(0x77);
	data(0x33);
	command(0x6f);
	data(0x00);
	command(0x7f);
	data(0x00);
	command(0x50);
	data(0x00);
	command(0x52);
	data(0xd6);
	command(0x53);
	data(0x04);
	command(0x54);
	data(0x04);
	command(0x55);
	data(0x1b);
	command(0x56);
	data(0x1b);
	command(0xa0);
	data(0x2a);
	data(0x24);
	data(0x00);
	command(0xa1);
	data(0x84);
	command(0xa2);
	data(0x85);
	command(0xa8);
	data(0x34);
	command(0xa9);
	data(0x80);
	command(0xaa);
	data(0x73);
	command(0xAB);
	data(0x03);
	data(0x61);
	command(0xAC);
	data(0x03);
	data(0x65);
	command(0xAD);
	data(0x03);
	data(0x60);
	command(0xAE);
	data(0x03);
	data(0x64);
	command(0xB9);
	data(0x82);
	command(0xBA);
	data(0x83);
	command(0xBB);
	data(0x80);
	command(0xBC);
	data(0x81);
	command(0xBD);
	data(0x02);
	command(0xBE);
	data(0x01);
	command(0xBF);
	data(0x04);
	command(0xC0);
	data(0x03);
	command(0xc4);
	data(0x33);
	command(0xc5);
	data(0x80);
	command(0xc6);
	data(0x73);
	command(0xc7);
	data(0x00);
	command(0xC8);
	data(0x33);
	data(0x33);
	command(0xC9);
	data(0x5b);
	command(0xCA);
	data(0x5a);
	command(0xCB);
	data(0x5d);
	command(0xCC);
	data(0x5c);
	command(0xCD);
	data(0x33);
	data(0x33);
	command(0xCE);
	data(0x5f);
	command(0xCF);
	data(0x5e);
	command(0xD0);
	data(0x61);
	command(0xD1);
	data(0x60);
	command(0xB0);
	data(0x3a);
	data(0x3a);
	data(0x00);
	data(0x00);
	command(0xB6);
	data(0x32);
	command(0xB7);
	data(0x80);
	command(0xB8);
	data(0x73);
	command(0xe0);
	data(0x00);
	command(0xe1);
	data(0x03);
	data(0x0f);
	command(0xe2);
	data(0x04);
	command(0xe3);
	data(0x01);
	command(0xe4);
	data(0x0e);
	command(0xe5);
	data(0x01);
	command(0xe6);
	data(0x19);
	command(0xe7);
	data(0x10);
	command(0xe8);
	data(0x10);
	command(0xe9);
	data(0x21);
	command(0xea);
	data(0x12);
	command(0xeb);
	data(0xd0);
	command(0xec);
	data(0x04);
	command(0xed);
	data(0x07);
	command(0xee);
	data(0x07);
	command(0xef);
	data(0x09);
	command(0xF0);
	data(0xD0);
	command(0xF1);
	data(0x0E);
	command(0xF9);
	data(0x56);
	command(0xf2);
	data(0x26);
	data(0x1b);
	data(0x0b);
	data(0x20);
	command(0xec);
	data(0x04);
	command(0x35);
	data(0x00);
	command(0x44);
	data(0x00);
	data(0x10);
	command(0x46);
	data(0x10);
	command(0xff);
	data(0x00);
	command(0x3a);
	data(0x05);
	command(0x36);
    	data(0x00);


  command(0x11); 
    bcm2835_delay(120);
  command(0x29); 


  
  nv3007_clear();


}

void nv3007_clear() {
        uint32_t i;
    for(i = 0; i < sizeof(buffer); i++)
    {
        buffer[i] = 0;
    }
}

void nv3007_draw_point(int x, int y, uint16_t hwColor) {
    if(x >= TFT_WIDTH || y >= TFT_HEIGHT)
    {
        return;
    }
    buffer[x * 2 + y * TFT_WIDTH * 2] = hwColor >> 8;
    buffer[x * 2 + y * TFT_WIDTH * 2 + 1] = hwColor;
}

void nv3007_char1616(uint16_t x, uint16_t y, uint8_t chChar, uint16_t hwColor) {
    uint8_t i, j;
    uint8_t chTemp = 0, y0 = y;

    for (i = 0; i < 32; i ++) {
        chTemp = Font1612[chChar - 0x30][i];
        for (j = 0; j < 8; j ++) {
            if (chTemp & 0x80) {
                nv3007_draw_point(x, y, hwColor);
            } else {
                nv3007_draw_point(x, y, 0);
            }
            chTemp <<= 1;
            y++;
            if ((y - y0) == 16) {
                y = y0;
                x++;
                break;
            }
        }
    }
}

void nv3007_char3216(uint16_t x, uint16_t y, uint8_t chChar, uint16_t hwColor) {
    uint8_t i, j;
    uint8_t chTemp = 0, y0 = y; 

    for (i = 0; i < 64; i++) {
        chTemp = Font3216[chChar - 0x30][i];
        for (j = 0; j < 8; j++) {
            if (chTemp & 0x80) {
                nv3007_draw_point(x, y, hwColor);
            } else {
                nv3007_draw_point(x, y, 0);
            }

            chTemp <<= 1;
            y++;
            if ((y - y0) == 32) {
                y = y0;
                x++;
                break;
            }
        }
    }
}

void nv3007_char(uint16_t x, uint16_t y, char acsii, char size, char mode, uint16_t hwColor) {
    uint16_t i, j, y0=y;
    char temp;
    uint8_t ch = acsii - ' ';
    for(i = 0;i<size;i++) {
        if(size == 12)
        {
            if(mode)temp=Font1206[ch][i];
            else temp = ~Font1206[ch][i];
        }
        else 
        {            
            if(mode)temp=Font1608[ch][i];
            else temp = ~Font1608[ch][i];
        }
        for(j =0;j<8;j++)
        {
            if(temp & 0x80) nv3007_draw_point(x, y, hwColor);
            else nv3007_draw_point(x, y, 0);
            temp <<=1;
            y++;
            if((y-y0)==size)
            {
                y = y0;
                x ++;
                break;
            }
        }
    }
}

void nv3007_string(uint16_t x, uint16_t y, const char *pString, uint8_t Size, uint8_t Mode, uint16_t hwColor) {
    while (*pString != '\0') {       
        if (x > (TFT_WIDTH - Size / 2)) {
            x = 0;
            y += Size;
            if (y > (TFT_HEIGHT - Size)) {
                y = x = 0;
            }
        }
        
        nv3007_char(x, y, *pString, Size, Mode, hwColor);
        x += Size / 2;
        pString ++;
    }
}

void nv3007_mono_bitmap(uint16_t x, uint16_t y, const uint8_t *pBmp, uint16_t chWidth, uint16_t chHeight, uint16_t hwColor) {
    uint16_t i, j, byteWidth = (chWidth + 7) / 8;
    for(j = 0; j < chHeight; j++) {
        for(i = 0; i <chWidth; i ++) {
            if(*(pBmp + j * byteWidth + i / 8) & (128 >> (i & 7))) {
                nv3007_draw_point(x + i, y + j, hwColor);
            }
        }
    }        
}

void nv3007_bitmap24(uint16_t x, uint16_t y, uint8_t *pBmp, uint16_t chWidth, uint16_t chHeight) {
    uint16_t i, j;
    uint16_t hwColor;
    uint32_t temp;

    for(j = 0; j < chHeight; j++) {
        for(i = 0; i < chWidth; i ++) {
            temp = *(unsigned int*)(pBmp + i * 3 + j * 3 * chWidth);
            hwColor = RGB(((temp >> 16) & 0xFF),
                          ((temp >> 8) & 0xFF),
                           (temp & 0xFF));
            nv3007_draw_point(x + i, y + chHeight - 1 - j, hwColor);
        }
    }
}



void nv3007_bitmap16(uint8_t x, uint16_t y, const uint8_t *pBmp, uint16_t chWidth, uint16_t  chHeight) {
    uint16_t i, j,temp;
    uint16_t hwColor;


    for(j = 0; j < chHeight; j++) {
        for(i = 0; i < chWidth; i ++) {
            hwColor= (*pBmp++);
            hwColor = hwColor<<8;
            temp = (*pBmp++);
	    hwColor = hwColor|temp;         
            nv3007_draw_point(x + i, y + j, hwColor);
        }
    }
}



void nv3007_display() {
 
    command(0x2a);
    data(0);
    data(12);
    data((TFT_WIDTH-1) >> 8);
    data((TFT_WIDTH-1+12) & 0xFF);

    command(0x2b);
    data(0);
    data(0);
    data((TFT_HEIGHT-1) >> 8);
    data((TFT_HEIGHT-1)& 0xFF);

    command(0x2C);
    bcm2835_gpio_write(DC, HIGH);
    bcm2835_spi_transfern(buffer, sizeof(buffer));
}

void nv3007_clear_screen(uint16_t hwColor) {
    uint16_t i, j;
    for(i = 0; i < TFT_HEIGHT; i++) {
        for(j = 0; j < TFT_WIDTH; j ++) {
            nv3007_draw_point(j, i, hwColor);
        }
    }
}

