/***************************************************
//Web: http://www.buydisplay.com
EastRising Technology Co.,LTD
Examples for ER-TFTM1.65-2
Display is Hardward SPI 4-Wire SPI Interface 
Tested and worked with: 
Works with Raspberry pi
****************************************************/

#include <bcm2835.h>
#include <stdio.h>
#include <time.h>
#include "nv3007.h"

char value[10] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9'};
int main(int argc, char **argv)
{
    time_t now;
    struct tm *timenow;
  //  FILE *pFile ;
    /* 1 pixel of 888 bitmap = 3 bytes */
  //  size_t pixelSize = 3;
 //   unsigned char bmpBuffer[TFT_WIDTH * TFT_HEIGHT * 3];

    if(!bcm2835_init())
    {
        return -1;
    }

 


  
    nv3007_begin();

    nv3007_clear_screen(0xf800);
    nv3007_display();
    bcm2835_delay(2000);

   nv3007_clear_screen(0x07e0);
    nv3007_display();
    bcm2835_delay(2000);

   nv3007_clear_screen(0x001f);
    nv3007_display();
    bcm2835_delay(2000);

    nv3007_mono_bitmap(10, 10, mono_bmp, 128, 128, GREEN);
    nv3007_display();
    bcm2835_delay(2000);


    nv3007_bitmap16(0, 0, pic1, 142, 428);
    nv3007_display();
    bcm2835_delay(2000);

    nv3007_bitmap16(0, 0, pic2, 142, 428);
    nv3007_display();
    bcm2835_delay(2000);

    nv3007_bitmap16(0, 0, pic3, 142, 428);
    nv3007_display();
    bcm2835_delay(2000);

   

    nv3007_clear();
    printf("TFT example. Press Ctrl + C to exit.\n");

    uint16_t i=100;
    while(1)
    {
        time(&now);
        timenow = localtime(&now);

        nv3007_mono_bitmap(0, 2, Signal816, 16, 8, GOLDEN); 
        nv3007_mono_bitmap(45, 2, Msg816, 16, 8, GOLDEN); 
        nv3007_mono_bitmap(90, 2, Bluetooth88, 8, 8, GOLDEN); 
        nv3007_mono_bitmap(135, 2, GPRS88, 8, 8, GOLDEN); 


        nv3007_string(0, 304, "MUSIC", 16, 0, WHITE); 
  
        nv3007_string(104, 304, "MENU", 16, 1, GOLDEN); 


        nv3007_char3216(0, 140, value[timenow->tm_hour / 10],RED);
        nv3007_char3216(16,140, value[timenow->tm_hour % 10],RED);
        nv3007_char3216(32, 140, ':' , WHITE);
        nv3007_char3216(48, 140, value[timenow->tm_min / 10], GREEN);
        nv3007_char3216(64, 140, value[timenow->tm_min % 10], GREEN);
        nv3007_char3216(80, 140, ':' , WHITE);
        nv3007_char3216(96, 140, value[timenow->tm_sec / 10],  BLUE);
        nv3007_char3216(112, 140, value[timenow->tm_sec % 10],  BLUE);

        nv3007_string(0, 220, "3w.buydisplay.com", 16, 1, i); 
	i+=1000; if(i>=65536)i=1000;
    
        nv3007_display();
      
    }
    bcm2835_spi_end();
    bcm2835_close();
    return 0;
}

